function [b, ScaleG, ZeroLimited] = CheckIfDecDir(Mu,G,V,Paths,FlowUsage);
ScaleG = 1;
Qo = EvalQ(Mu,V,Paths, FlowUsage);
JJ = find(G<0);
ZeroLimited=0;
if (isempty(JJ)==0)
    h1 = min(-Mu(JJ)./G(JJ));
    if ( (EvalQ(Mu+h1*G,V,Paths, FlowUsage) <= Qo && 1e-3/norm(G)>h1) || h1<1e-12)
        % is h1 is too small, then we do not count Q1=Qo as decreasing
        ScaleG = h1;
        b=1;
        ZeroLimited=1;
        return
    end
end
h = 1e-3/norm(G);
Q1 = EvalQ(Mu+h*G,V,Paths, FlowUsage);
if (Q1<Qo)
    ScaleG = h;
    b = 1;
    return;
end

if (norm(G)==0)
    b = 1;
    return
end

% might not be decreasing
while (Q1-Qo==0)
    h = h * 2;
    Q1 = EvalQ(Mu+h*G,V,Paths, FlowUsage);
end

L = 0;
while (h-L>1e-12)
    u = EvalQ(Mu+(L+h)/2*G,V,Paths, FlowUsage)-Qo;
    if (u<0)
        b = 1;
        ScaleG = (L+h)/2;
        return
    end
    if (u==0)
        L = (L+h)/2;
    else
        h = (L+h)/2;
    end
end
b = 0;