VMu = V*Mu;
I = find(VMu>=max(VMu)-MaxAcc*max(VMu)); 

FR=zeros(length(Paths),1);
for i=1:length(Paths)
    FR(i) = 1/sum(Mu(Paths{i})); % flow rates
end
 LF=zeros(size(V,2),1);
 for i=1:size(V,2)
     LF(i) = sum(FR(FlowUsage{i}));    % link rates 
 end
    
A = -V(I,:)';
f = ones(size(A,2),1);
b = -LF + max(1e-6*LF,1e-6); % link rates should be within 1% of desired
aa = sum(A,2);
SchSuc = 0;
SchCond = 0;

if (max(aa(find(b<0)))<0)
    SchCond = 1;
    % LP will is feasible
    xo = ones(length(f),1) * max(b(find(b<0))./aa(find(b<0)));
    Name = 'lpQG'; % Problem name, not required.
    b_U = b;
    x_L = zeros(length(f),1);
    % b_L, x_U and x_0 have default values and need not be defined.
    % It is possible to call lpAssign with empty [] arguments instead
    b_L = -inf+0*b_U;
    x_U = inf+0*x_L;
    x_0 = xo;
    Prob = lpAssign(f, A, b_L, b_U, x_L, x_U, x_0, Name,[], [], [], [], [], [], []);    
    Result = tomRun('pdco', Prob, 0);
    if (Result.ExitFlag~=0)
        Result = tomRun('lpSimplex', Prob, 0);
    end       
    if (Result.ExitFlag==0)
        SchCond = 2;
        xx = Result.x_k;
        FR2 = FR / sum(xx);
        if (SchDisplay==1)
            disp(sprintf('time to reach demand = %f, actual util=%f mu util=%f',sum(xx),sum(log(FR2)),sum(log(FR))))
        end
        if (abs(sum(xx)-1)<=0.001 && abs(sum(log(FR2))-sum(log(FR)))/abs(sum(log(FR)))<.001 )
            if (SchDisplay==1 || SchDisplay==2)
                disp('time to reach is ok and utility is ok... done');
            end
            SchSuc = 1;
        end        
        finalSch = xx;
        finalAssign = S(I,:); %-A';      
    end
end

