function NewMu = SubGradLineSearch(G,Mu,V,Paths, FlowUsage)
    Qo = EvalQ(Mu,V,Paths, FlowUsage);
    
    JJ = find(G<0 & Mu>0);
    if (isempty(JJ)==0)
        h = min(-Mu(JJ)./G(JJ));
        QMaxUp = EvalQ(max(0,Mu+h*G),V,Paths, FlowUsage);
    else
        QMaxUp = inf;
    end
    if (QMaxUp<=Qo )
        MaxDistIsDec = 1;
        UpperSz = h;
    else
        UpperSz = 1;
        MaxDistIsDec = 0;
    end    
    sz = 1/norm(G) * .01;
        
    QUpper = EvalQ(max(0,Mu+UpperSz*G),V,Paths, FlowUsage);
    while (QUpper<Qo && MaxDistIsDec==0 )
        UpperSz = UpperSz*2;
        QUpper = EvalQ(max(0,Mu+UpperSz*G),V,Paths, FlowUsage);
    end
    
    % binary search
    LowerQ = Qo;
    LowerSz = 0;
    QL=Qo+1; QH=QL;
    while ( (UpperSz-LowerSz>1e-5*UpperSz || QL>=Qo || QH>=Qo) && UpperSz-LowerSz>1e-14*UpperSz )
        CL = LowerSz*.75 + UpperSz*.25;
        CH = LowerSz*.25 + UpperSz*.75;
        QL = EvalQ(max(0,Mu+CL*G),V,Paths, FlowUsage);
        QH = EvalQ(max(0,Mu+CH*G),V,Paths, FlowUsage);
        if (QH<=QL)
            LowerSz = CL;
            LowerQ = QL;
        else
            UpperSz = CH;
            UpperQ = QH;
        end
    end
    if ( UpperSz-LowerSz<1e-14*UpperSz && MaxDistIsDec==0)
        disp('exiting line search since direction is not a descent direction')
        if (min(Mu(find(Mu>0)))<1e-12*max(Mu))
            % make some elements exactly zero
            I = find(Mu>0);
            I = I(find(Mu(I)<1e-12*max(Mu)));
            NewMu  = Mu;
            NewMu(I)=0;
            %Q = EvalQ(NewMu,V,Paths, FlowUsage);
            return
        end
    end
    if (MaxDistIsDec==1)
        if (QMaxUp <= EvalQ(max(0,Mu+(UpperSz+LowerSz)/2*G),V,Paths, FlowUsage))
            NewMu = Mu+h*G;
            I = find(Mu>0 & G<0);
            H = -Mu(I)./G(I);
            II = I(find(H==min(H)));
            NewMu(II(1))=0;
            if (min(NewMu(find(NewMu>0)))<1e-12*max(NewMu))
                % make some elements exactly zero
                I = find(NewMu<1e-12*max(NewMu));
                NewMu(I)=0;
            end
            return
        end
    end
    NewMu = max(0,Mu + (UpperSz+LowerSz)/2*G);
    %Q = EvalQ(NewMu,V,Paths, FlowUsage);
            
            
        
    
        
    

